#ifndef _ADUNANZA_H_
#define _ADUNANZA_H_

#define V(M, m) _T(#M) _T(".") _T(#m)
#define _V(M, m) V(M,m)

#define B(n, l) _T(#n) _T(l)
#define _B(n, l) B(n, l)

#define ADU_VER_MAJ   3
#define ADU_VER_MIN   11

#define ADU_VER_RL _V(ADU_VER_MAJ, ADU_VER_MIN)

#define ADU_BETA_MAJ 0
#define ADU_BETA_MIN ""

#if ADU_BETA_MAJ > 0
	#define ADU_VER ADU_VER_RL _T("b") _B(ADU_BETA_MAJ, ADU_BETA_MIN)
#else
	#define ADU_VER ADU_VER_RL _T("b")
#endif

#define ADU_MOD_NAME _T("AdunanzA")
#define ADU_MOD ADU_MOD_NAME _T(" ") ADU_VER

#include "OPCodes.h"

#ifdef HAVE_CONFIG_H
	#include "config.h"			//   VERSION
#endif

#ifdef __CVS__
	#define	MOD_VERSION_LONG		ADU_MOD wxT(" - aMule CVS")
#else
	#define	MOD_VERSION_LONG		ADU_MOD wxT(" - aMule ") wxT(VERSION)
#endif

// Parametri e definzioni esportate dal file AdunanzA.cpp
#define ADUNANZA_ANY		0
#define ADUNANZA_EXTERN		1
#define ADUNANZA_FASTWEB	2
#define ADUNANZA_NONE    0xff

// Definizioni per icone e per riconoscimento client
#define ADUNANZA_ICON_NONE  0
#define ADUNANZA_ICON_FW	1
#define ADUNANZA_ICON_ADU	2

// Percentuale minima per assegnare uno slot ad un Adu
//#define ADUNANZA_MIN_ADU	5
// Definizione default del numero di slots
#define ADUNANZA_DEF_UPSL	8
// Definizione default banda Adu
//#define ADUNANZA_BAND_PERC	85
// Definizione connessione automatica
#define ADUNANZA_AUTO_CONN	1
// Definizione forzature upload/dl ext 1:1 - Disabilitato di default
#define ADUNANZA_AUTO_EXT11	1

#define ADU_VER_CODE(M,m,o) (((M) << 12) + ((m) << 7) + (o))
#define ADU_GET_MAJ(v) ((v) >> 12)
#define ADU_GET_MIN(v) (((v) >> 7) & 0x1f)
#define ADU_GET_B(v) ((v) & 0x7f)

// ADU URLS
#define ADURM_URL "http://update.adunanza.net/3-10/adu_remote.conf"
//#define ADU_SRV_URL "http://ocbmaurice.dyns.net/pl/slist.pl?download/server-best.met"
#define ADU_SRV_URL "http://corpo.free.fr/server.met"
#define ADU_NODES_DAT "http://update.adunanza.net/adu_nodes.dat"

/*
MAN Milano........................   1.0.0.0/8
MAN Milano hinterland Nord........   2.0.0.0/8
MAN Genova........................   5.0.0.0/8
MAN Veneto........................  11.0.0.0/8
MAN Milano hinterland Sud.........  14.0.0.0/8
MAN Ancona........................  21.0.0.0/8
MAN Grosseto......................  22.0.0.0/8
MAN Roma..........................  23.0.0.0/8
MAN Toscana.......................  27.0.0.0/8
MAN Triveneto.....................  29.0.0.0/8
MAN Bari..........................  31.0.0.0/8
MAN Sicilia.......................  36.0.0.0/8
MAN Bologna.......................  37.0.0.0/8
MAN Napoli........................  39.0.0.0/8
MAN Torino........................  41.0.0.0/8
MAN Reggio Emilia.................  42.0.0.0/8

Routers & OAM.....................  10.0.0.0/8
Organization, Administration & Management (ad. es.: Server interni ntp, voip, billing etc. etc.)
*/

// Definizione zone italia FW
#define MAN_MILANO 1
#define MAN_MILANO_H_NORD 2
#define MAN_GENOVA 5
#define FASTWEB_ROUTERS 10
#define MAN_VENETO 11
#define MAN_MILANO_H_SUD 14
#define MAN_ANCONA 21
#define MAN_GROSSETO 22
#define MAN_ROMA 23
#define MAN_TOSCANA 27
#define MAN_TRIVENETO 29
#define MAN_BARI 31
#define MAN_SICILIA 36
#define MAN_BOLOGNA 37
#define MAN_NAPOLI 39
#define MAN_TORINO 41
#define MAN_REGGIO_EMILIA 42

// Funzioni esportate
extern bool		AduIsFastWebIP(uint32 ip);
extern bool		AduIsFastWebLANIP(uint32 ip);
extern bool		AduIsFiber(uint32 ip);
extern uint32	AduGetTypeBand();
extern bool		IsAduServer(uint32 CurServer);
extern uint32	AduGetMaxUploadSlots(void);
//extern float	AduGetPercBandwidth(void);
extern void		AduStartConnection(void);
extern void*	AduGetNextAduServer(int value, int& num);
extern void		AduUpdate(char *url);
// KAdu
extern bool     AduIsValidKaduAddress( uint32 host );

extern float   calcolaStima( float avail, uint32& firstPublish, uint32 publishInterval, uint32 pubkRTK, bool sameIP, uint32 now );
extern float   normalizzaStima( float avail, uint32 from, uint32 to );

#ifndef CLIENT_GUI
uint32 AduNextClient(int fix = 0);
bool AduMaxTrans(void);
#endif

#endif

